diff -Naur test-for-latech/net/socket.c testqf-for-latech/net/socket.c
--- test-for-latech/net/socket.c	2004-06-11 07:40:47.000000000 -0400
+++ testqf-for-latech/net/socket.c	2004-06-11 07:47:56.000000000 -0400
@@ -457,6 +457,9 @@
 	sock->ops = NULL;
 	sock->sk = NULL;
 	sock->file = NULL;
+#ifdef CONFIG_QFABRIC
+	sock->rt_sock = 0;
+#endif
 
 	sockets_in_use[smp_processor_id()].counter++;
 	return sock;
@@ -498,6 +501,24 @@
 	sock->file=NULL;
 }
 
+#ifdef CONFIG_QFABRIC
+int rt_sock_sendmsg(struct socket *sock, struct msghdr *msg, int size, int deadline,
+	int flags)
+{
+	int err;
+	struct scm_cookie scm;
+
+	sock->deadline = deadline;
+	sock->rt_flags = flags;
+	err = scm_send(sock, msg, &scm);
+	if (err >= 0) {
+		err = sock->ops->sendmsg(sock, msg, size, &scm);
+		scm_destroy(&scm);
+	}
+	return err;
+}
+#endif
+
 int sock_sendmsg(struct socket *sock, struct msghdr *msg, int size)
 {
 	int err;
@@ -819,6 +840,13 @@
 	return 0;
 }
 
+#ifdef CONFIG_QFABRIC
+int make_rt_sock(struct socket *sock) 
+{
+	sock->rt_sock = 1;	
+	return 0;
+}
+#endif
 
 int sock_create(int family, int type, int protocol, struct socket **res)
 {
@@ -855,7 +883,7 @@
 	 * Otherwise module support will break!
 	 */
 	if (net_families[family]==NULL)
-	{
+{
 		char module_name[30];
 		sprintf(module_name,"net-pf-%d",family);
 		request_module(module_name);
@@ -883,6 +911,9 @@
 	}
 
 	sock->type  = type;
+#ifdef CONFIG_QFABRIC
+	sock->rt_sock  = 0;
+#endif
 
 	if ((i = net_families[family]->create(sock, protocol)) < 0) 
 	{
@@ -909,6 +940,15 @@
 	retval = sock_map_fd(sock);
 	if (retval < 0)
 		goto out_release;
+#ifdef CONFIG_QFABRIC
+	sock->sk->fd = retval;
+	sock->sk->owner = current->pid;
+	sock->sk->kecho = 0;
+	sock->sk->readable = 0;
+	sock->sk->writable = 0;
+	sock->sk->counter = 0;
+	sock->rt_sock = 0;
+#endif
 
 out:
 	/* It may be already another descriptor 8) Not kernel problem. */
@@ -919,6 +959,37 @@
 	return retval;
 }
 
+#ifdef CONFIG_QFABRIC
+asmlinkage long sys_rtsocket(int family, int type, int protocol)
+{
+	int retval;
+	struct socket *sock;
+
+	retval = sock_create(family, type, protocol, &sock);
+	if (retval < 0)
+		goto out;
+
+	retval = sock_map_fd(sock);
+	if (retval < 0)
+		goto out_release;
+	sock->sk->fd = retval;
+	sock->sk->owner = current->pid;
+	sock->sk->kecho = 0;
+	sock->sk->readable = 0;
+	sock->sk->writable = 0;
+	sock->sk->counter = 0;
+	sock->rt_sock = 1;
+
+out:
+	/* It may be already another descriptor 8) Not kernel problem. */
+	return retval;
+
+out_release:
+	sock_release(sock);
+	return retval;
+}
+#endif
+
 /*
  *	Create a pair of connected sockets.
  */
@@ -1063,6 +1134,13 @@
 	if (err < 0)
 		goto out_release;
 
+#ifdef CONFIG_QFABRIC
+	sock->sk->fd = err;
+	sock->sk->owner = current->pid;
+	sock->sk->readable = 0;
+	sock->sk->writable = 0;
+#endif
+
 	if (upeer_sockaddr) {
 		if(newsock->ops->getname(newsock, (struct sockaddr *)address, &len, 2)<0) {
 			err = -ECONNABORTED;
@@ -1258,6 +1336,9 @@
 		if(err2<0)
 			err=err2;
 	}
+#ifdef CONFIG_QFABRIC
+	if (err > 0) sock->sk->counter++;
+#endif
 	sockfd_put(sock);			
 out:
 	return err;
@@ -1553,6 +1634,11 @@
 		case SYS_SOCKET:
 			err = sys_socket(a0,a1,a[2]);
 			break;
+#ifdef CONFIG_QFABRIC
+		case SYS_RTSOCKET:
+			err = sys_rtsocket(a0,a1,a[2]);
+			break;
+#endif
 		case SYS_BIND:
 			err = sys_bind(a0,(struct sockaddr *)a1, a[2]);
 			break;
@@ -1662,6 +1748,10 @@
 extern void bluez_init(void);
 #endif
 
+#ifdef CONFIG_X86
+extern void qsocket_init(void);
+#endif
+
 void __init sock_init(void)
 {
 	int i;
@@ -1725,6 +1815,11 @@
 #ifdef CONFIG_BLUEZ
 	bluez_init();
 #endif
+#ifdef CONFIG_X86
+#ifdef CONFIG_NET_QSOCKET
+	qsocket_init();
+#endif
+#endif
 }
 
 int socket_get_info(char *buffer, char **start, off_t offset, int length)
@@ -1753,3 +1848,28 @@
 		len = 0;
 	return len;
 }
+
+#ifdef CONFIG_QFABRIC
+int set_socket_deadline(struct sock *sk, int deadline) 
+{
+	sk->socket->deadline = deadline;
+	return 0;
+}
+
+int request_socket_deadline(struct sock *sk)
+{
+	return sk->socket->deadline;
+}
+
+int set_socket_rt_flags(struct sock *sk, int flags)
+{
+	sk->socket->rt_flags = flags;
+	return 0;
+}
+
+int request_socket_rt_flags(struct sock *sk)
+{
+	return sk->socket->rt_flags;
+}
+#endif
+
